/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the Criterion type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &Criterion{}

// Criterion struct for Criterion
type Criterion struct {
	Id            NullableString `json:"id,omitempty"`
	Description   NullableString `json:"description,omitempty"`
	ExampleValues NullableString `json:"exampleValues,omitempty"`
	Datatype      NullableString `json:"datatype,omitempty"`
	Restricted    *bool          `json:"restricted,omitempty"`
}

// NewCriterion instantiates a new Criterion object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewCriterion() *Criterion {
	this := Criterion{}
	return &this
}

// NewCriterionWithDefaults instantiates a new Criterion object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewCriterionWithDefaults() *Criterion {
	this := Criterion{}
	return &this
}

// GetId returns the Id field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Criterion) GetId() string {
	if o == nil || IsNil(o.Id.Get()) {
		var ret string
		return ret
	}
	return *o.Id.Get()
}

// GetIdOk returns a tuple with the Id field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Criterion) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Id.Get(), o.Id.IsSet()
}

// HasId returns a boolean if a field has been set.
func (o *Criterion) HasId() bool {
	if o != nil && o.Id.IsSet() {
		return true
	}

	return false
}

// SetId gets a reference to the given NullableString and assigns it to the Id field.
func (o *Criterion) SetId(v string) {
	o.Id.Set(&v)
}

// SetIdNil sets the value for Id to be an explicit nil
func (o *Criterion) SetIdNil() {
	o.Id.Set(nil)
}

// UnsetId ensures that no value is present for Id, not even an explicit nil
func (o *Criterion) UnsetId() {
	o.Id.Unset()
}

// GetDescription returns the Description field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Criterion) GetDescription() string {
	if o == nil || IsNil(o.Description.Get()) {
		var ret string
		return ret
	}
	return *o.Description.Get()
}

// GetDescriptionOk returns a tuple with the Description field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Criterion) GetDescriptionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Description.Get(), o.Description.IsSet()
}

// HasDescription returns a boolean if a field has been set.
func (o *Criterion) HasDescription() bool {
	if o != nil && o.Description.IsSet() {
		return true
	}

	return false
}

// SetDescription gets a reference to the given NullableString and assigns it to the Description field.
func (o *Criterion) SetDescription(v string) {
	o.Description.Set(&v)
}

// SetDescriptionNil sets the value for Description to be an explicit nil
func (o *Criterion) SetDescriptionNil() {
	o.Description.Set(nil)
}

// UnsetDescription ensures that no value is present for Description, not even an explicit nil
func (o *Criterion) UnsetDescription() {
	o.Description.Unset()
}

// GetExampleValues returns the ExampleValues field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Criterion) GetExampleValues() string {
	if o == nil || IsNil(o.ExampleValues.Get()) {
		var ret string
		return ret
	}
	return *o.ExampleValues.Get()
}

// GetExampleValuesOk returns a tuple with the ExampleValues field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Criterion) GetExampleValuesOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.ExampleValues.Get(), o.ExampleValues.IsSet()
}

// HasExampleValues returns a boolean if a field has been set.
func (o *Criterion) HasExampleValues() bool {
	if o != nil && o.ExampleValues.IsSet() {
		return true
	}

	return false
}

// SetExampleValues gets a reference to the given NullableString and assigns it to the ExampleValues field.
func (o *Criterion) SetExampleValues(v string) {
	o.ExampleValues.Set(&v)
}

// SetExampleValuesNil sets the value for ExampleValues to be an explicit nil
func (o *Criterion) SetExampleValuesNil() {
	o.ExampleValues.Set(nil)
}

// UnsetExampleValues ensures that no value is present for ExampleValues, not even an explicit nil
func (o *Criterion) UnsetExampleValues() {
	o.ExampleValues.Unset()
}

// GetDatatype returns the Datatype field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *Criterion) GetDatatype() string {
	if o == nil || IsNil(o.Datatype.Get()) {
		var ret string
		return ret
	}
	return *o.Datatype.Get()
}

// GetDatatypeOk returns a tuple with the Datatype field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *Criterion) GetDatatypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Datatype.Get(), o.Datatype.IsSet()
}

// HasDatatype returns a boolean if a field has been set.
func (o *Criterion) HasDatatype() bool {
	if o != nil && o.Datatype.IsSet() {
		return true
	}

	return false
}

// SetDatatype gets a reference to the given NullableString and assigns it to the Datatype field.
func (o *Criterion) SetDatatype(v string) {
	o.Datatype.Set(&v)
}

// SetDatatypeNil sets the value for Datatype to be an explicit nil
func (o *Criterion) SetDatatypeNil() {
	o.Datatype.Set(nil)
}

// UnsetDatatype ensures that no value is present for Datatype, not even an explicit nil
func (o *Criterion) UnsetDatatype() {
	o.Datatype.Unset()
}

// GetRestricted returns the Restricted field value if set, zero value otherwise.
func (o *Criterion) GetRestricted() bool {
	if o == nil || IsNil(o.Restricted) {
		var ret bool
		return ret
	}
	return *o.Restricted
}

// GetRestrictedOk returns a tuple with the Restricted field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *Criterion) GetRestrictedOk() (*bool, bool) {
	if o == nil || IsNil(o.Restricted) {
		return nil, false
	}
	return o.Restricted, true
}

// HasRestricted returns a boolean if a field has been set.
func (o *Criterion) HasRestricted() bool {
	if o != nil && !IsNil(o.Restricted) {
		return true
	}

	return false
}

// SetRestricted gets a reference to the given bool and assigns it to the Restricted field.
func (o *Criterion) SetRestricted(v bool) {
	o.Restricted = &v
}

func (o Criterion) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o Criterion) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.Id.IsSet() {
		toSerialize["id"] = o.Id.Get()
	}
	if o.Description.IsSet() {
		toSerialize["description"] = o.Description.Get()
	}
	if o.ExampleValues.IsSet() {
		toSerialize["exampleValues"] = o.ExampleValues.Get()
	}
	if o.Datatype.IsSet() {
		toSerialize["datatype"] = o.Datatype.Get()
	}
	if !IsNil(o.Restricted) {
		toSerialize["restricted"] = o.Restricted
	}
	return toSerialize, nil
}

type NullableCriterion struct {
	value *Criterion
	isSet bool
}

func (v NullableCriterion) Get() *Criterion {
	return v.value
}

func (v *NullableCriterion) Set(val *Criterion) {
	v.value = val
	v.isSet = true
}

func (v NullableCriterion) IsSet() bool {
	return v.isSet
}

func (v *NullableCriterion) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableCriterion(val *Criterion) *NullableCriterion {
	return &NullableCriterion{value: val, isSet: true}
}

func (v NullableCriterion) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableCriterion) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
